Index: c/src/lib/libbsp/m68k/gen68360/ChangeLog
===================================================================
--- c/src/lib/libbsp/m68k/gen68360/ChangeLog	(revision bdcf02d460cbf5b2566110cdb02298f05faaf928)
+++ c/src/lib/libbsp/m68k/gen68360/ChangeLog	(revision 695ccb211fb3b4957ef585e7a57f515cf2bb6773)
@@ -1,2 +1,8 @@
+2000-09-04	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* clock/Makefile.am, console/Makefile.am, network/Makefile.am,
+	start/Makefile.am, startup/Makefile.am, timer/Makefile.am,
+	wrapup/Makefile.am: Include compile.am
+
 2000-08-10	Joel Sherrill <joel@OARcorp.com>
 
Index: c/src/lib/libbsp/m68k/gen68360/clock/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/gen68360/clock/Makefile.am	(revision bdcf02d460cbf5b2566110cdb02298f05faaf928)
+++ c/src/lib/libbsp/m68k/gen68360/clock/Makefile.am	(revision 695ccb211fb3b4957ef585e7a57f515cf2bb6773)
@@ -13,4 +13,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
 include $(top_srcdir)/../../../../../../automake/lib.am
 
Index: c/src/lib/libbsp/m68k/gen68360/console/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/gen68360/console/Makefile.am	(revision bdcf02d460cbf5b2566110cdb02298f05faaf928)
+++ c/src/lib/libbsp/m68k/gen68360/console/Makefile.am	(revision 695ccb211fb3b4957ef585e7a57f515cf2bb6773)
@@ -13,4 +13,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
 include $(top_srcdir)/../../../../../../automake/lib.am
 
Index: c/src/lib/libbsp/m68k/gen68360/network/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/gen68360/network/Makefile.am	(revision bdcf02d460cbf5b2566110cdb02298f05faaf928)
+++ c/src/lib/libbsp/m68k/gen68360/network/Makefile.am	(revision 695ccb211fb3b4957ef585e7a57f515cf2bb6773)
@@ -13,4 +13,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
 include $(top_srcdir)/../../../../../../automake/lib.am
 
Index: c/src/lib/libbsp/m68k/gen68360/start/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/gen68360/start/Makefile.am	(revision bdcf02d460cbf5b2566110cdb02298f05faaf928)
+++ c/src/lib/libbsp/m68k/gen68360/start/Makefile.am	(revision 695ccb211fb3b4957ef585e7a57f515cf2bb6773)
@@ -13,4 +13,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
 include $(top_srcdir)/../../../../../../automake/lib.am
 
Index: c/src/lib/libbsp/m68k/gen68360/startup/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/gen68360/startup/Makefile.am	(revision bdcf02d460cbf5b2566110cdb02298f05faaf928)
+++ c/src/lib/libbsp/m68k/gen68360/startup/Makefile.am	(revision 695ccb211fb3b4957ef585e7a57f515cf2bb6773)
@@ -17,4 +17,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
 include $(top_srcdir)/../../../../../../automake/lib.am
 
Index: c/src/lib/libbsp/m68k/gen68360/timer/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/gen68360/timer/Makefile.am	(revision bdcf02d460cbf5b2566110cdb02298f05faaf928)
+++ c/src/lib/libbsp/m68k/gen68360/timer/Makefile.am	(revision 695ccb211fb3b4957ef585e7a57f515cf2bb6773)
@@ -13,4 +13,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
 include $(top_srcdir)/../../../../../../automake/lib.am
 
Index: c/src/lib/libbsp/m68k/gen68360/wrapup/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/gen68360/wrapup/Makefile.am	(revision bdcf02d460cbf5b2566110cdb02298f05faaf928)
+++ c/src/lib/libbsp/m68k/gen68360/wrapup/Makefile.am	(revision 695ccb211fb3b4957ef585e7a57f515cf2bb6773)
@@ -18,4 +18,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
 include $(top_srcdir)/../../../../../../automake/lib.am
 