Index: cpukit/ChangeLog
===================================================================
--- cpukit/ChangeLog	(revision 6fd4d06f395cefdebe2a8e5c02c89e7792ae9a25)
+++ cpukit/ChangeLog	(revision 708fe56b6c9830c8d7a11c573927d6bc9782c73b)
@@ -1,2 +1,9 @@
+2009-09-28	Joel Sherrill <joel.sherrill@OARcorp.com>
+
+	* rtems/src/regiondelete.c, rtems/src/regiongetfreeinfo.c,
+	rtems/src/regiongetinfo.c, rtems/src/regiongetsegment.c,
+	rtems/src/regiongetsegmentsize.c, rtems/src/regionresizesegment.c,
+	rtems/src/regionreturnsegment.c: Remove warnings.
+
 2009-09-28	Joel Sherrill <joel.sherrill@OARcorp.com>
 
Index: cpukit/rtems/src/regiondelete.c
===================================================================
--- cpukit/rtems/src/regiondelete.c	(revision 6fd4d06f395cefdebe2a8e5c02c89e7792ae9a25)
+++ cpukit/rtems/src/regiondelete.c	(revision 708fe56b6c9830c8d7a11c573927d6bc9782c73b)
@@ -48,5 +48,5 @@
 {
   Objects_Locations        location;
-  rtems_status_code        return_status;
+  rtems_status_code        return_status = RTEMS_SUCCESSFUL;
   register Region_Control *the_region;
 
@@ -63,5 +63,4 @@
           _Objects_Close( &_Region_Information, &the_region->Object );
           _Region_Free( the_region );
-          return_status = RTEMS_SUCCESSFUL;
         }
         break;
Index: cpukit/rtems/src/regiongetfreeinfo.c
===================================================================
--- cpukit/rtems/src/regiongetfreeinfo.c	(revision 6fd4d06f395cefdebe2a8e5c02c89e7792ae9a25)
+++ cpukit/rtems/src/regiongetfreeinfo.c	(revision 708fe56b6c9830c8d7a11c573927d6bc9782c73b)
@@ -51,5 +51,5 @@
 {
   Objects_Locations        location;
-  rtems_status_code        return_status;
+  rtems_status_code        return_status = RTEMS_SUCCESSFUL;
   register Region_Control *the_region;
 
Index: cpukit/rtems/src/regiongetinfo.c
===================================================================
--- cpukit/rtems/src/regiongetinfo.c	(revision 6fd4d06f395cefdebe2a8e5c02c89e7792ae9a25)
+++ cpukit/rtems/src/regiongetinfo.c	(revision 708fe56b6c9830c8d7a11c573927d6bc9782c73b)
@@ -49,5 +49,5 @@
 {
   Objects_Locations        location;
-  rtems_status_code        return_status;
+  rtems_status_code        return_status = RTEMS_SUCCESSFUL;
   register Region_Control *the_region;
 
@@ -62,5 +62,4 @@
       case OBJECTS_LOCAL:
         _Heap_Get_information( &the_region->Memory, the_info );
-        return_status = RTEMS_SUCCESSFUL;
         break;
 
Index: cpukit/rtems/src/regiongetsegment.c
===================================================================
--- cpukit/rtems/src/regiongetsegment.c	(revision 6fd4d06f395cefdebe2a8e5c02c89e7792ae9a25)
+++ cpukit/rtems/src/regiongetsegment.c	(revision 708fe56b6c9830c8d7a11c573927d6bc9782c73b)
@@ -56,5 +56,5 @@
   Thread_Control          *executing;
   Objects_Locations        location;
-  rtems_status_code        return_status;
+  rtems_status_code        return_status = RTEMS_SUCCESSFUL;
   register Region_Control *the_region;
   void                    *the_segment;
@@ -88,5 +88,4 @@
             the_region->number_of_used_blocks += 1;
             *segment = the_segment;
-            return_status = RTEMS_SUCCESSFUL;
           }
 
Index: cpukit/rtems/src/regiongetsegmentsize.c
===================================================================
--- cpukit/rtems/src/regiongetsegmentsize.c	(revision 6fd4d06f395cefdebe2a8e5c02c89e7792ae9a25)
+++ cpukit/rtems/src/regiongetsegmentsize.c	(revision 708fe56b6c9830c8d7a11c573927d6bc9782c73b)
@@ -50,5 +50,5 @@
 {
   Objects_Locations        location;
-  rtems_status_code        return_status;
+  rtems_status_code        return_status = RTEMS_SUCCESSFUL;
   register Region_Control *the_region;
 
@@ -67,6 +67,4 @@
         if ( !_Heap_Size_of_alloc_area( &the_region->Memory, segment, size ) )
           return_status = RTEMS_INVALID_ADDRESS;
-        else
-          return_status = RTEMS_SUCCESSFUL;
         break;
 
Index: cpukit/rtems/src/regionresizesegment.c
===================================================================
--- cpukit/rtems/src/regionresizesegment.c	(revision 6fd4d06f395cefdebe2a8e5c02c89e7792ae9a25)
+++ cpukit/rtems/src/regionresizesegment.c	(revision 708fe56b6c9830c8d7a11c573927d6bc9782c73b)
@@ -54,5 +54,5 @@
   Objects_Locations        location;
   uintptr_t                osize;
-  rtems_status_code        return_status;
+  rtems_status_code        return_status = RTEMS_SUCCESSFUL;
   Heap_Resize_status       status;
   register Region_Control *the_region;
Index: cpukit/rtems/src/regionreturnsegment.c
===================================================================
--- cpukit/rtems/src/regionreturnsegment.c	(revision 6fd4d06f395cefdebe2a8e5c02c89e7792ae9a25)
+++ cpukit/rtems/src/regionreturnsegment.c	(revision 708fe56b6c9830c8d7a11c573927d6bc9782c73b)
@@ -56,5 +56,5 @@
 {
   Objects_Locations        location;
-  rtems_status_code        return_status;
+  rtems_status_code        return_status = RTEMS_SUCCESSFUL;
 #ifdef RTEMS_REGION_FREE_SHRED_PATTERN
   uint32_t                 size;