Index: c/src/tests/itrontests/Makefile.am
===================================================================
--- c/src/tests/itrontests/Makefile.am	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ c/src/tests/itrontests/Makefile.am	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -14,8 +14,7 @@
 all-local: $(PREINSTALLDIRS)
 
-ITRON_DIRS = itronhello itrontask01 itrontask02 itrontask03 itrontask04 \
+SUBDIRS = . itronhello itrontask01 itrontask02 itrontask03 itrontask04 \
     itronmbf01 itronsem01 itrontime01
 
-SUBDIRS = $(ITRON_DIRS)
 
 include $(top_srcdir)/../../../../automake/subdirs.am
Index: c/src/tests/itrontests/itronhello/system.h
===================================================================
--- c/src/tests/itrontests/itronhello/system.h	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ c/src/tests/itrontests/itronhello/system.h	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -16,4 +16,5 @@
 
 #include <tmacros.h>
+#include <itron.h>
 
 /* functions */
Index: c/src/tests/itrontests/itronmbf01/init.c
===================================================================
--- c/src/tests/itrontests/itronmbf01/init.c	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ c/src/tests/itrontests/itronmbf01/init.c	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -48,6 +48,7 @@
 void ITRON_Init( void )
 {
-    printf( "\n\n*** ITRONMBF01 -- ITRON MESSAGE BUFFER TEST ***\n" );
-
+    puts( "\n\n*** ITRONMBF01 -- ITRON MESSAGE BUFFER TEST ***" );
+
+#if 0
     TestCre();
     TestDel();
@@ -58,6 +59,9 @@
     TestPrcv();
     TestTrcv();
-
-    printf("\n\n*** ITRONMBF01 --- ITRON MESSAGE BUFFER TEST ***\n");
+#else
+    puts("Enable the code in this test when messages buffers are implemented"); 
+#endif
+
+    printf("*** ITRONMBF01 --- ITRON MESSAGE BUFFER TEST ***");
     exit(0);
 }
Index: c/src/tests/itrontests/itronmbf01/system.h
===================================================================
--- c/src/tests/itrontests/itronmbf01/system.h	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ c/src/tests/itrontests/itronmbf01/system.h	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -16,4 +16,5 @@
 
 #include <tmacros.h>
+#include <itron.h>
 
 /* functions */
Index: c/src/tests/itrontests/itrontask01/system.h
===================================================================
--- c/src/tests/itrontests/itrontask01/system.h	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ c/src/tests/itrontests/itrontask01/system.h	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -16,4 +16,5 @@
 
 #include <tmacros.h>
+#include <itron.h>
 
 /* functions */
Index: c/src/tests/itrontests/itrontask02/system.h
===================================================================
--- c/src/tests/itrontests/itrontask02/system.h	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ c/src/tests/itrontests/itrontask02/system.h	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -16,4 +16,5 @@
 
 #include <tmacros.h>
+#include <itron.h>
 
 /* functions */
Index: c/src/tests/itrontests/itrontask03/itrontask03.scn
===================================================================
--- c/src/tests/itrontests/itrontask03/itrontask03.scn	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ c/src/tests/itrontests/itrontask03/itrontask03.scn	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -7,5 +7,5 @@
 TA3 - rtems_task_wake_after - sleep 5 seconds
 TA1 - chg_pri - set TA3's priority to 2
-TA1 - rtems_task_suspend - suspend TA2
+TA1 - sus_tsk - suspend TA2
 TA1 -  - delete TA2
 TA1 - rtems_task_wake_after - sleep for 5 seconds
Index: c/src/tests/itrontests/itrontask03/system.h
===================================================================
--- c/src/tests/itrontests/itrontask03/system.h	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ c/src/tests/itrontests/itrontask03/system.h	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -16,4 +16,5 @@
 
 #include <tmacros.h>
+#include <itron.h>
 
 /* functions */
Index: c/src/tests/itrontests/itrontask03/task1.c
===================================================================
--- c/src/tests/itrontests/itrontask03/task1.c	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ c/src/tests/itrontests/itrontask03/task1.c	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -39,5 +39,5 @@
   puts( "TA1 - chg_pri - set TA3's priority to 2" );
 
-  puts( "TA1 - rtems_task_suspend - suspend TA2" );
+  puts( "TA1 - sus_tsk - suspend TA2" );
   status = sus_tsk( TA2_ID  );
   directive_failed( status, "sus_tsk of TA2" );
Index: c/src/tests/itrontests/itrontask04/system.h
===================================================================
--- c/src/tests/itrontests/itrontask04/system.h	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ c/src/tests/itrontests/itrontask04/system.h	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -16,4 +16,5 @@
 
 #include <tmacros.h>
+#include <itron.h>
 
 /* functions */
Index: c/src/tests/itrontests/itrontime01/system.h
===================================================================
--- c/src/tests/itrontests/itrontime01/system.h	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ c/src/tests/itrontests/itrontime01/system.h	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -16,4 +16,5 @@
 
 #include <tmacros.h>
+#include <itron.h>
 
 /* functions */
Index: testsuites/itrontests/Makefile.am
===================================================================
--- testsuites/itrontests/Makefile.am	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ testsuites/itrontests/Makefile.am	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -14,8 +14,7 @@
 all-local: $(PREINSTALLDIRS)
 
-ITRON_DIRS = itronhello itrontask01 itrontask02 itrontask03 itrontask04 \
+SUBDIRS = . itronhello itrontask01 itrontask02 itrontask03 itrontask04 \
     itronmbf01 itronsem01 itrontime01
 
-SUBDIRS = $(ITRON_DIRS)
 
 include $(top_srcdir)/../../../../automake/subdirs.am
Index: testsuites/itrontests/itronhello/system.h
===================================================================
--- testsuites/itrontests/itronhello/system.h	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ testsuites/itrontests/itronhello/system.h	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -16,4 +16,5 @@
 
 #include <tmacros.h>
+#include <itron.h>
 
 /* functions */
Index: testsuites/itrontests/itronmbf01/init.c
===================================================================
--- testsuites/itrontests/itronmbf01/init.c	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ testsuites/itrontests/itronmbf01/init.c	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -48,6 +48,7 @@
 void ITRON_Init( void )
 {
-    printf( "\n\n*** ITRONMBF01 -- ITRON MESSAGE BUFFER TEST ***\n" );
-
+    puts( "\n\n*** ITRONMBF01 -- ITRON MESSAGE BUFFER TEST ***" );
+
+#if 0
     TestCre();
     TestDel();
@@ -58,6 +59,9 @@
     TestPrcv();
     TestTrcv();
-
-    printf("\n\n*** ITRONMBF01 --- ITRON MESSAGE BUFFER TEST ***\n");
+#else
+    puts("Enable the code in this test when messages buffers are implemented"); 
+#endif
+
+    printf("*** ITRONMBF01 --- ITRON MESSAGE BUFFER TEST ***");
     exit(0);
 }
Index: testsuites/itrontests/itronmbf01/system.h
===================================================================
--- testsuites/itrontests/itronmbf01/system.h	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ testsuites/itrontests/itronmbf01/system.h	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -16,4 +16,5 @@
 
 #include <tmacros.h>
+#include <itron.h>
 
 /* functions */
Index: testsuites/itrontests/itrontask01/system.h
===================================================================
--- testsuites/itrontests/itrontask01/system.h	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ testsuites/itrontests/itrontask01/system.h	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -16,4 +16,5 @@
 
 #include <tmacros.h>
+#include <itron.h>
 
 /* functions */
Index: testsuites/itrontests/itrontask02/system.h
===================================================================
--- testsuites/itrontests/itrontask02/system.h	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ testsuites/itrontests/itrontask02/system.h	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -16,4 +16,5 @@
 
 #include <tmacros.h>
+#include <itron.h>
 
 /* functions */
Index: testsuites/itrontests/itrontask03/itrontask03.scn
===================================================================
--- testsuites/itrontests/itrontask03/itrontask03.scn	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ testsuites/itrontests/itrontask03/itrontask03.scn	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -7,5 +7,5 @@
 TA3 - rtems_task_wake_after - sleep 5 seconds
 TA1 - chg_pri - set TA3's priority to 2
-TA1 - rtems_task_suspend - suspend TA2
+TA1 - sus_tsk - suspend TA2
 TA1 -  - delete TA2
 TA1 - rtems_task_wake_after - sleep for 5 seconds
Index: testsuites/itrontests/itrontask03/system.h
===================================================================
--- testsuites/itrontests/itrontask03/system.h	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ testsuites/itrontests/itrontask03/system.h	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -16,4 +16,5 @@
 
 #include <tmacros.h>
+#include <itron.h>
 
 /* functions */
Index: testsuites/itrontests/itrontask03/task1.c
===================================================================
--- testsuites/itrontests/itrontask03/task1.c	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ testsuites/itrontests/itrontask03/task1.c	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -39,5 +39,5 @@
   puts( "TA1 - chg_pri - set TA3's priority to 2" );
 
-  puts( "TA1 - rtems_task_suspend - suspend TA2" );
+  puts( "TA1 - sus_tsk - suspend TA2" );
   status = sus_tsk( TA2_ID  );
   directive_failed( status, "sus_tsk of TA2" );
Index: testsuites/itrontests/itrontask04/system.h
===================================================================
--- testsuites/itrontests/itrontask04/system.h	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ testsuites/itrontests/itrontask04/system.h	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -16,4 +16,5 @@
 
 #include <tmacros.h>
+#include <itron.h>
 
 /* functions */
Index: testsuites/itrontests/itrontime01/system.h
===================================================================
--- testsuites/itrontests/itrontime01/system.h	(revision 59d1127f13d5bb2e4048ef2adbf59dc536689d48)
+++ testsuites/itrontests/itrontime01/system.h	(revision 713b2eac2fdb0a40056ddb8eb00250541df0a3b2)
@@ -16,4 +16,5 @@
 
 #include <tmacros.h>
+#include <itron.h>
 
 /* functions */