Index: c/src/libnetworking/ChangeLog
===================================================================
--- c/src/libnetworking/ChangeLog	(revision 11a3703225b4357b8cbe8c642ffe932b1eee013f)
+++ c/src/libnetworking/ChangeLog	(revision 0725ce327fff8898b26cae83628ba117de65b4ce)
@@ -1,2 +1,10 @@
+2004-01-14	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* pppd/Makefile.am: Re-add dirstamps to PRE/TMPINSTALL_FILES.
+	Add PRE/TMPINSTALL_FILES to CLEANFILES.
+	* rtems_servers/Makefile.am: Ditto.
+	* rtems_telnetd/Makefile.am: Ditto.
+	* rtems_webserver/Makefile.am: Ditto.
+
 2003-12-12	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: c/src/libnetworking/pppd/Makefile.am
===================================================================
--- c/src/libnetworking/pppd/Makefile.am	(revision 11a3703225b4357b8cbe8c642ffe932b1eee013f)
+++ c/src/libnetworking/pppd/Makefile.am	(revision 0725ce327fff8898b26cae83628ba117de65b4ce)
@@ -40,4 +40,5 @@
 	@$(mkdir_p) $(PROJECT_INCLUDE)
 	@: > $(PROJECT_INCLUDE)/$(dirstamp)
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/$(dirstamp)
 
 if HAS_NETWORKING
@@ -51,3 +52,5 @@
 endif
 
+CLEANFILES = $(PREINSTALL_FILES)
+
 include $(top_srcdir)/automake/local.am
Index: c/src/libnetworking/rtems_servers/Makefile.am
===================================================================
--- c/src/libnetworking/rtems_servers/Makefile.am	(revision 11a3703225b4357b8cbe8c642ffe932b1eee013f)
+++ c/src/libnetworking/rtems_servers/Makefile.am	(revision 0725ce327fff8898b26cae83628ba117de65b4ce)
@@ -38,4 +38,5 @@
 	@$(mkdir_p) $(PROJECT_INCLUDE)
 	@: > $(PROJECT_INCLUDE)/$(dirstamp)
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/$(dirstamp)
 
 if HAS_NETWORKING
@@ -43,4 +44,5 @@
 	@$(mkdir_p) $(PROJECT_INCLUDE)/rtems
 	@: > $(PROJECT_INCLUDE)/rtems/$(dirstamp)
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/rtems/$(dirstamp)
 
 $(PROJECT_INCLUDE)/ftpd.h: ftpd.h $(PROJECT_INCLUDE)/$(dirstamp)
@@ -49,3 +51,5 @@
 endif
 
+CLEANFILES = $(PREINSTALL_FILES)
+
 include $(top_srcdir)/automake/local.am
Index: c/src/libnetworking/rtems_telnetd/Makefile.am
===================================================================
--- c/src/libnetworking/rtems_telnetd/Makefile.am	(revision 11a3703225b4357b8cbe8c642ffe932b1eee013f)
+++ c/src/libnetworking/rtems_telnetd/Makefile.am	(revision 0725ce327fff8898b26cae83628ba117de65b4ce)
@@ -36,4 +36,5 @@
 	@$(mkdir_p) $(PROJECT_INCLUDE)/rtems
 	@: > $(PROJECT_INCLUDE)/rtems/$(dirstamp)
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/rtems/$(dirstamp)
 
 $(PROJECT_INCLUDE)/rtems/pty.h: pty.h $(PROJECT_INCLUDE)/rtems/$(dirstamp)
@@ -46,3 +47,5 @@
 endif
 
+CLEANFILES = $(PREINSTALL_FILES)
+
 include $(top_srcdir)/automake/local.am
Index: c/src/libnetworking/rtems_webserver/Makefile.am
===================================================================
--- c/src/libnetworking/rtems_webserver/Makefile.am	(revision 11a3703225b4357b8cbe8c642ffe932b1eee013f)
+++ c/src/libnetworking/rtems_webserver/Makefile.am	(revision 0725ce327fff8898b26cae83628ba117de65b4ce)
@@ -49,4 +49,5 @@
 	@$(mkdir_p) $(PROJECT_INCLUDE)
 	@: > $(PROJECT_INCLUDE)/$(dirstamp)
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/$(dirstamp)
 
 if HAS_NETWORKING
@@ -55,4 +56,5 @@
 	@$(mkdir_p) $(PROJECT_INCLUDE)/goahead
 	@: > $(PROJECT_INCLUDE)/goahead/$(dirstamp)
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/goahead/$(dirstamp)
 
 $(PROJECT_INCLUDE)/rtems_webserver.h: rtems_webserver.h $(PROJECT_INCLUDE)/$(dirstamp)
@@ -94,3 +96,5 @@
 endif
 
+CLEANFILES = $(PREINSTALL_FILES)
+
 include $(top_srcdir)/automake/local.am
Index: cpukit/ftpd/Makefile.am
===================================================================
--- cpukit/ftpd/Makefile.am	(revision 11a3703225b4357b8cbe8c642ffe932b1eee013f)
+++ cpukit/ftpd/Makefile.am	(revision 0725ce327fff8898b26cae83628ba117de65b4ce)
@@ -38,4 +38,5 @@
 	@$(mkdir_p) $(PROJECT_INCLUDE)
 	@: > $(PROJECT_INCLUDE)/$(dirstamp)
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/$(dirstamp)
 
 if HAS_NETWORKING
@@ -43,4 +44,5 @@
 	@$(mkdir_p) $(PROJECT_INCLUDE)/rtems
 	@: > $(PROJECT_INCLUDE)/rtems/$(dirstamp)
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/rtems/$(dirstamp)
 
 $(PROJECT_INCLUDE)/ftpd.h: ftpd.h $(PROJECT_INCLUDE)/$(dirstamp)
@@ -49,3 +51,5 @@
 endif
 
+CLEANFILES = $(PREINSTALL_FILES)
+
 include $(top_srcdir)/automake/local.am
Index: cpukit/httpd/Makefile.am
===================================================================
--- cpukit/httpd/Makefile.am	(revision 11a3703225b4357b8cbe8c642ffe932b1eee013f)
+++ cpukit/httpd/Makefile.am	(revision 0725ce327fff8898b26cae83628ba117de65b4ce)
@@ -49,4 +49,5 @@
 	@$(mkdir_p) $(PROJECT_INCLUDE)
 	@: > $(PROJECT_INCLUDE)/$(dirstamp)
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/$(dirstamp)
 
 if HAS_NETWORKING
@@ -55,4 +56,5 @@
 	@$(mkdir_p) $(PROJECT_INCLUDE)/goahead
 	@: > $(PROJECT_INCLUDE)/goahead/$(dirstamp)
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/goahead/$(dirstamp)
 
 $(PROJECT_INCLUDE)/rtems_webserver.h: rtems_webserver.h $(PROJECT_INCLUDE)/$(dirstamp)
@@ -94,3 +96,5 @@
 endif
 
+CLEANFILES = $(PREINSTALL_FILES)
+
 include $(top_srcdir)/automake/local.am
Index: cpukit/pppd/Makefile.am
===================================================================
--- cpukit/pppd/Makefile.am	(revision 11a3703225b4357b8cbe8c642ffe932b1eee013f)
+++ cpukit/pppd/Makefile.am	(revision 0725ce327fff8898b26cae83628ba117de65b4ce)
@@ -40,4 +40,5 @@
 	@$(mkdir_p) $(PROJECT_INCLUDE)
 	@: > $(PROJECT_INCLUDE)/$(dirstamp)
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/$(dirstamp)
 
 if HAS_NETWORKING
@@ -51,3 +52,5 @@
 endif
 
+CLEANFILES = $(PREINSTALL_FILES)
+
 include $(top_srcdir)/automake/local.am
Index: cpukit/telnetd/Makefile.am
===================================================================
--- cpukit/telnetd/Makefile.am	(revision 11a3703225b4357b8cbe8c642ffe932b1eee013f)
+++ cpukit/telnetd/Makefile.am	(revision 0725ce327fff8898b26cae83628ba117de65b4ce)
@@ -36,4 +36,5 @@
 	@$(mkdir_p) $(PROJECT_INCLUDE)/rtems
 	@: > $(PROJECT_INCLUDE)/rtems/$(dirstamp)
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/rtems/$(dirstamp)
 
 $(PROJECT_INCLUDE)/rtems/pty.h: pty.h $(PROJECT_INCLUDE)/rtems/$(dirstamp)
@@ -46,3 +47,5 @@
 endif
 
+CLEANFILES = $(PREINSTALL_FILES)
+
 include $(top_srcdir)/automake/local.am