Index: cpukit/backward/asm.h
===================================================================
--- cpukit/backward/asm.h	(revision 47148e4f854e050217dcb14b6c9abd9374b1802a)
+++ cpukit/backward/asm.h	(revision 736f024feef9975482b4019adb58dfa9fa851c26)
@@ -1,2 +1,7 @@
+/**
+ * @file asm.h
+ * @deprecated
+ */
+
 #ifndef __asm_h
 #define __asm_h
Index: cpukit/backward/chain.h
===================================================================
--- cpukit/backward/chain.h	(revision 47148e4f854e050217dcb14b6c9abd9374b1802a)
+++ cpukit/backward/chain.h	(revision 736f024feef9975482b4019adb58dfa9fa851c26)
@@ -1,2 +1,7 @@
+/**
+ * @file chain.h
+ * @deprecated
+ */
+
 #ifndef __chain_h
 #define __chain_h
Index: cpukit/backward/clockdrv.h
===================================================================
--- cpukit/backward/clockdrv.h	(revision 47148e4f854e050217dcb14b6c9abd9374b1802a)
+++ cpukit/backward/clockdrv.h	(revision 736f024feef9975482b4019adb58dfa9fa851c26)
@@ -1,2 +1,7 @@
+/**
+ * @file clockdrv.h
+ * @deprecated
+ */
+
 #ifndef __clockdrv_h
 #define __clockdrv_h
Index: cpukit/backward/confdefs.h
===================================================================
--- cpukit/backward/confdefs.h	(revision 47148e4f854e050217dcb14b6c9abd9374b1802a)
+++ cpukit/backward/confdefs.h	(revision 736f024feef9975482b4019adb58dfa9fa851c26)
@@ -1,2 +1,7 @@
+/**
+ * @file confdefs.h
+ * @deprecated
+ */
+
 #ifndef __confdefs_h
 #define __confdefs_h
Index: cpukit/backward/console.h
===================================================================
--- cpukit/backward/console.h	(revision 47148e4f854e050217dcb14b6c9abd9374b1802a)
+++ cpukit/backward/console.h	(revision 736f024feef9975482b4019adb58dfa9fa851c26)
@@ -1,2 +1,7 @@
+/**
+ * @file console.h
+ * @deprecated
+ */
+
 #ifndef __console_h
 #define __console_h
Index: cpukit/backward/dosfs.h
===================================================================
--- cpukit/backward/dosfs.h	(revision 47148e4f854e050217dcb14b6c9abd9374b1802a)
+++ cpukit/backward/dosfs.h	(revision 736f024feef9975482b4019adb58dfa9fa851c26)
@@ -1,2 +1,7 @@
+/**
+ * @file dosfs.h
+ * @deprecated
+ */
+
 #ifndef __dosfs_h
 #define __dosfs_h
Index: cpukit/backward/imfs.h
===================================================================
--- cpukit/backward/imfs.h	(revision 47148e4f854e050217dcb14b6c9abd9374b1802a)
+++ cpukit/backward/imfs.h	(revision 736f024feef9975482b4019adb58dfa9fa851c26)
@@ -1,2 +1,7 @@
+/**
+ * @file imfs.h
+ * @deprecated
+ */
+
 #ifndef __imfs_h
 #define __imfs_h
Index: cpukit/backward/iosupp.h
===================================================================
--- cpukit/backward/iosupp.h	(revision 47148e4f854e050217dcb14b6c9abd9374b1802a)
+++ cpukit/backward/iosupp.h	(revision 736f024feef9975482b4019adb58dfa9fa851c26)
@@ -1,2 +1,7 @@
+/**
+ * @file iosupp.h
+ * @deprecated
+ */
+
 #ifndef __iosupp_h
 #define __iosupp_h
Index: cpukit/backward/itron.h
===================================================================
--- cpukit/backward/itron.h	(revision 47148e4f854e050217dcb14b6c9abd9374b1802a)
+++ cpukit/backward/itron.h	(revision 736f024feef9975482b4019adb58dfa9fa851c26)
@@ -1,2 +1,7 @@
+/**
+ * @file itron.h
+ * @deprecated
+ */
+
 #ifndef __itron_h
 #define __itron_h
Index: cpukit/backward/motorola/mc68230.h
===================================================================
--- cpukit/backward/motorola/mc68230.h	(revision 47148e4f854e050217dcb14b6c9abd9374b1802a)
+++ cpukit/backward/motorola/mc68230.h	(revision 736f024feef9975482b4019adb58dfa9fa851c26)
@@ -1,2 +1,7 @@
+/**
+ * @file motorola/mc68230.h
+ * @deprecated
+ */
+
 #ifndef __motorola_mc68230_h
 #define __motorola_mc68230_h
Index: cpukit/backward/motorola/mc68681.h
===================================================================
--- cpukit/backward/motorola/mc68681.h	(revision 47148e4f854e050217dcb14b6c9abd9374b1802a)
+++ cpukit/backward/motorola/mc68681.h	(revision 736f024feef9975482b4019adb58dfa9fa851c26)
@@ -1,2 +1,7 @@
+/**
+ * @file motorola/mc68681.h
+ * @deprecated
+ */
+
 #ifndef __motorola_mc68681_h
 #define __motorola_mc68681_h
Index: cpukit/backward/ringbuf.h
===================================================================
--- cpukit/backward/ringbuf.h	(revision 47148e4f854e050217dcb14b6c9abd9374b1802a)
+++ cpukit/backward/ringbuf.h	(revision 736f024feef9975482b4019adb58dfa9fa851c26)
@@ -1,2 +1,7 @@
+/**
+ * @file ringbuf.h
+ * @deprecated
+ */
+
 #ifndef __ringbuf_h
 #define __ringbuf_h
Index: cpukit/backward/rtc.h
===================================================================
--- cpukit/backward/rtc.h	(revision 47148e4f854e050217dcb14b6c9abd9374b1802a)
+++ cpukit/backward/rtc.h	(revision 736f024feef9975482b4019adb58dfa9fa851c26)
@@ -1,2 +1,7 @@
+/**
+ * @file rtc.h
+ * @deprecated
+ */
+
 #ifndef __rtc_h
 #define __rtc_h
Index: cpukit/backward/spurious.h
===================================================================
--- cpukit/backward/spurious.h	(revision 47148e4f854e050217dcb14b6c9abd9374b1802a)
+++ cpukit/backward/spurious.h	(revision 736f024feef9975482b4019adb58dfa9fa851c26)
@@ -1,2 +1,7 @@
+/**
+ * @file spurious.h
+ * @deprecated
+ */
+
 #ifndef __spurious_h
 #define __spurious_h
Index: cpukit/backward/timerdrv.h
===================================================================
--- cpukit/backward/timerdrv.h	(revision 47148e4f854e050217dcb14b6c9abd9374b1802a)
+++ cpukit/backward/timerdrv.h	(revision 736f024feef9975482b4019adb58dfa9fa851c26)
@@ -1,2 +1,7 @@
+/**
+ * @file timerdrv.h
+ * @deprecated
+ */
+
 #ifndef __timerdrv_h
 #define __timerdrv_h
Index: cpukit/backward/vmeintr.h
===================================================================
--- cpukit/backward/vmeintr.h	(revision 47148e4f854e050217dcb14b6c9abd9374b1802a)
+++ cpukit/backward/vmeintr.h	(revision 736f024feef9975482b4019adb58dfa9fa851c26)
@@ -1,2 +1,7 @@
+/**
+ * @file vmeintr.h
+ * @deprecated
+ */
+
 #ifndef __vmeintr_h
 #define __vmeintr_h
Index: cpukit/backward/zilog/z8030.h
===================================================================
--- cpukit/backward/zilog/z8030.h	(revision 47148e4f854e050217dcb14b6c9abd9374b1802a)
+++ cpukit/backward/zilog/z8030.h	(revision 736f024feef9975482b4019adb58dfa9fa851c26)
@@ -1,2 +1,7 @@
+/**
+ * @file zilog/z8030.h
+ * @deprecated
+ */
+
 #ifndef __zilog_z8030_h
 #define __zilog_z8030_h
Index: cpukit/backward/zilog/z8036.h
===================================================================
--- cpukit/backward/zilog/z8036.h	(revision 47148e4f854e050217dcb14b6c9abd9374b1802a)
+++ cpukit/backward/zilog/z8036.h	(revision 736f024feef9975482b4019adb58dfa9fa851c26)
@@ -1,2 +1,7 @@
+/**
+ * @file zilog/z8036.h
+ * @deprecated
+ */
+
 #ifndef __zilog_z8036_h
 #define __zilog_z8036_h
Index: cpukit/backward/zilog/z8536.h
===================================================================
--- cpukit/backward/zilog/z8536.h	(revision 47148e4f854e050217dcb14b6c9abd9374b1802a)
+++ cpukit/backward/zilog/z8536.h	(revision 736f024feef9975482b4019adb58dfa9fa851c26)
@@ -1,2 +1,7 @@
+/**
+ * @file zilog/z8536.h
+ * @deprecated
+ */
+
 #ifndef __zilog_z8536_h
 #define __zilog_z8536_h