Index: cpukit/ChangeLog
===================================================================
--- cpukit/ChangeLog	(revision 46a1aa9efac2935fc4536ffb77fe86361330fc04)
+++ cpukit/ChangeLog	(revision 751c51343c0a0769c1f6829dd2051c7cf263272c)
@@ -1,2 +1,14 @@
+2004-12-03	Ralf Corsepius <ralf.corsepius@rtems.org>
+
+	* libnetworking/net/if_ethersubr.c,
+	libnetworking/net/radix.h,
+	libnetworking/netinet/if_ether.h,
+	libnetworking/netinet/igmp_var.h,
+	libnetworking/netinet/in_var.h,
+	libnetworking/netinet/tcp_timer.h,
+	libnetworking/netinet/udp_usrreq.c,
+	libnetworking/rtems/rtems_glue.c:
+	Misc. updates from FreeBSD and bugfixes tripped by GCC-4.0.0.
+
 2004-12-02	Ralf Corsepius <ralf.corsepius@rtems.org>
 
Index: cpukit/libnetworking/net/if_ethersubr.c
===================================================================
--- cpukit/libnetworking/net/if_ethersubr.c	(revision 46a1aa9efac2935fc4536ffb77fe86361330fc04)
+++ cpukit/libnetworking/net/if_ethersubr.c	(revision 751c51343c0a0769c1f6829dd2051c7cf263272c)
@@ -555,8 +555,16 @@
 }
 
+#if defined(__rtems__)
+u_char ether_ipmulticast_min[6] = 
+	{ 0x01, 0x00, 0x5e, 0x00, 0x00, 0x00 };
+u_char ether_ipmulticast_max[6] =
+	{ 0x01, 0x00, 0x5e, 0x7f, 0xff, 0xff };
+#else
 static u_char ether_ipmulticast_min[6] = 
 	{ 0x01, 0x00, 0x5e, 0x00, 0x00, 0x00 };
 static u_char ether_ipmulticast_max[6] =
 	{ 0x01, 0x00, 0x5e, 0x7f, 0xff, 0xff };
+#endif
+
 /*
  * Add an Ethernet multicast address or range of addresses to the list for a
Index: cpukit/libnetworking/net/radix.h
===================================================================
--- cpukit/libnetworking/net/radix.h	(revision 46a1aa9efac2935fc4536ffb77fe86361330fc04)
+++ cpukit/libnetworking/net/radix.h	(revision 751c51343c0a0769c1f6829dd2051c7cf263272c)
@@ -148,6 +148,4 @@
 #endif /*_KERNEL*/
 
-extern struct radix_node_head *mask_rnhead;
-
 void	 rn_init(void);
 int	 rn_inithead(void **, int);
Index: cpukit/libnetworking/netinet/if_ether.h
===================================================================
--- cpukit/libnetworking/netinet/if_ether.h	(revision 46a1aa9efac2935fc4536ffb77fe86361330fc04)
+++ cpukit/libnetworking/netinet/if_ether.h	(revision 751c51343c0a0769c1f6829dd2051c7cf263272c)
@@ -40,20 +40,4 @@
 #include <net/ethernet.h>
 #include <net/if_arp.h>
-
-#define	ETHERTYPE_PUP		0x0200	/* PUP protocol */
-#define	ETHERTYPE_IP		0x0800	/* IP protocol */
-#define ETHERTYPE_ARP		0x0806	/* Addr. resolution protocol */
-#define ETHERTYPE_REVARP	0x8035	/* reverse Addr. resolution protocol */
-
-/*
- * The ETHERTYPE_NTRAILER packet types starting at ETHERTYPE_TRAIL have
- * (type-ETHERTYPE_TRAIL)*512 bytes of data followed
- * by an ETHER type (as given above) and then the (variable-length) header.
- */
-#define	ETHERTYPE_TRAIL		0x1000		/* Trailer packet */
-#define	ETHERTYPE_NTRAILER	16
-
-#define	ETHERMTU	(ETHER_MAX_LEN-ETHER_HDR_LEN-ETHER_CRC_LEN)
-#define	ETHERMIN	(ETHER_MIN_LEN-ETHER_HDR_LEN-ETHER_CRC_LEN)
 
 #ifdef _KERNEL
Index: cpukit/libnetworking/netinet/igmp_var.h
===================================================================
--- cpukit/libnetworking/netinet/igmp_var.h	(revision 46a1aa9efac2935fc4536ffb77fe86361330fc04)
+++ cpukit/libnetworking/netinet/igmp_var.h	(revision 751c51343c0a0769c1f6829dd2051c7cf263272c)
@@ -60,6 +60,4 @@
 
 #ifdef _KERNEL
-extern struct igmpstat igmpstat;
-
 #define IGMP_RANDOM_DELAY(X) (random() % (X) + 1)
 
Index: cpukit/libnetworking/netinet/in_var.h
===================================================================
--- cpukit/libnetworking/netinet/in_var.h	(revision 46a1aa9efac2935fc4536ffb77fe86361330fc04)
+++ cpukit/libnetworking/netinet/in_var.h	(revision 751c51343c0a0769c1f6829dd2051c7cf263272c)
@@ -1,2 +1,3 @@
+/* $Id */
 /*
  * Copyright (c) 1985, 1986, 1993
@@ -87,7 +88,4 @@
 extern	struct	in_addr zeroin_addr;
 extern	u_char	inetctlerrmap[];
-extern	int rtq_reallyold;	/* XXX */
-extern	int rtq_minreallyold;	/* XXX */
-extern	int rtq_toomany;	/* XXX */
 
 /*
Index: cpukit/libnetworking/netinet/tcp_timer.h
===================================================================
--- cpukit/libnetworking/netinet/tcp_timer.h	(revision 46a1aa9efac2935fc4536ffb77fe86361330fc04)
+++ cpukit/libnetworking/netinet/tcp_timer.h	(revision 751c51343c0a0769c1f6829dd2051c7cf263272c)
@@ -126,5 +126,4 @@
 extern int tcp_keepinit;		/* time to establish connection */
 extern int tcp_keepidle;		/* time before keepalive probes begin */
-extern int tcp_keepintvl;		/* time between keepalive probes */
 extern int tcp_maxidle;			/* time to drop after starting probes */
 extern int tcp_ttl;			/* time to live for TCP segs */
Index: cpukit/libnetworking/netinet/udp_usrreq.c
===================================================================
--- cpukit/libnetworking/netinet/udp_usrreq.c	(revision 46a1aa9efac2935fc4536ffb77fe86361330fc04)
+++ cpukit/libnetworking/netinet/udp_usrreq.c	(revision 751c51343c0a0769c1f6829dd2051c7cf263272c)
@@ -74,6 +74,6 @@
 	&log_in_vain, 0, "");
 
-static struct	inpcbhead udb;		/* from udp_var.h */
-static struct	inpcbinfo udbinfo;
+struct	inpcbhead udb;		/* from udp_var.h */
+struct	inpcbinfo udbinfo;
 
 #ifndef UDBHASHSIZE
Index: cpukit/libnetworking/rtems/rtems_glue.c
===================================================================
--- cpukit/libnetworking/rtems/rtems_glue.c	(revision 46a1aa9efac2935fc4536ffb77fe86361330fc04)
+++ cpukit/libnetworking/rtems/rtems_glue.c	(revision 751c51343c0a0769c1f6829dd2051c7cf263272c)
@@ -74,5 +74,6 @@
  */
 static rtems_interval	ticksWhenCalloutsLastChecked;
-static struct callout *callfree, calltodo;
+struct callout *callfree = NULL;
+struct callout calltodo;
 
 /*